function str_ralign(size, fill_ch)
{
    var s = this;
    while (s.length < size) s = fill_ch + s;
    return s;
}
String.prototype.ralign = str_ralign;




main(WScript.Arguments)


function main(argv)
{
    // name of the file which was given as argument
    var filename;
    // type of the file (i.e. file ending);
    var filetype;
    var WshShell = WScript.CreateObject("WScript.Shell");
    var fso = new ActiveXObject("Scripting.FileSystemObject");
    // name of the destination document filename
    var destFilename;
    // name of the destination document directory
    var destDirname;
    var destpath;
    var i;
    


    if(argv.length !=1)
    {
	alert('Wrong number of arguments');
	exit(0);
    }
    
    filename = argv(0);

    if(!fso.fileExists(filename))
    {
	alert("Script error: The specified file does not exists!");
	alert(filename);
	exit(1);
    }

    text = getCurrentAddressInfo();
    text = "Soll die ausgewhlte Email als Dokument zur folgender Adresse gespeichert werden?"
	+ "\r\n\r\n" + text;
    rc = WshShell.Popup(text,0,"Email als Dokument speichern?",32+4);

    // pressed "no" button
    if(rc==7)
    {
	fso.DeleteFile(filename);
	exit(0);
    }

    destDir = getCurrentAddressDocDir();
    // no document directory entry in database -> generate it
    if(destDir == null || destDir.length<10)
    {
	genDocDirEntry();
	destDir = getCurrentAddressDocDir();
    }
    if(!fso.FolderExists(destDir))
    {
	// fixme/warning: CreateFolder does not create folders recursively
	var dummy = fso.CreateFolder(destDir);
	if(dummy == null)
	{
	    alert("Script error: Was not able to create destDir");
	    exit(1);
	}
    }

    
    // generate unique destFilename and check if it exists
    destFilename = "email_" + iso8601date() + ".eml";
    destPath = fso.BuildPath(destDir,destFilename);
    i = 1
    while(fso.fileExists(destPath) && i<200)
    {
	destFilename = "email_" + iso8601date() + "_" + i + ".eml";
	destPath = fso.BuildPath(destDir,destFilename);
	i++;
    }
    if(i>=200)
    {
	alert("Script Error: Something wrent wrong. Could not generate destFilename");
	exit(1);
    }

    fso.CopyFile(filename,destPath);
    if(!fso.fileExists(destPath))
    {
	alert("Script Error: Could not copy filename to destPath");
	exit(1);
    }

    writeDocInfoToAddress();
    
    
    fso.DeleteFile(filename);

}


/* gets informational textual information of actual selected
   address entry for display to user
*/
function getCurrentAddressInfo()
{
    var firma;
    var nachname;
    var vorname;
    var PLZ;
    var Ort;
    
    
    // dummy code
    firma = "Testfirma";
    vorname = "Testvorname";
    nachname = "Testnachname";
    PLZ = "testPLZ";
    Ort = "testOrt";
    
    
    text = firma + "\r\n" + vorname + " " + nachname + "\r\n" + PLZ + " " + Ort;
    return text;
}


function exit(code)
{
    WScript.Quit(code);
}

function alert(text)
{
    WScript.Echo(text);
}

/* generate iso8601 style dates
*/
function iso8601date()
{
    var date = new Date();
    var text = new String();

    text =  date.getFullYear() + "-" + (date.getMonth()+1).toString().ralign(2,"0");
    text += "-" + date.getDate().toString().ralign(2,"0");	
    
    return text;
}

/* returns the document dir of the currently selected address
   in crm system
*/
function getCurrentAddressDocDir()
{

    // dummy code
    return "c:\\temp\\testdocdir\\0001";

}

/* writes the document information into database
*/
function writeDocInfoToAddress()
{
    // dummy code
    

}
